package com.iusmob.ad_klein_flutter_sdk;

import android.util.Log;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.iusmob.adklein.ad.AdKleinError;
import com.iusmob.adklein.ad.AdKleinFullscreenVideoAd;
import com.iusmob.adklein.ad.AdKleinFullscreenVideoAdListener;

public class FlutterFullScreenVodAd extends FlutterAd.FlutterOverlayAd implements FlutterDestroyableAd {

    @NonNull
    private final AdInstanceManager manager;
    /**
     * 广告位id
     */
    @NonNull
    private final String adPosId;
    /**
     * 广告对象
     */
    private AdKleinFullscreenVideoAd fullscreenVideo;

    @Override
    void show() {
        if (fullscreenVideo != null) {
            fullscreenVideo.show();
        }
    }

    static class Builder {
        @Nullable
        private AdInstanceManager manager;
        @Nullable
        private String adPosId;

        public Builder setManager(@NonNull AdInstanceManager manager) {
            this.manager = manager;
            return this;
        }

        public Builder setAdPosId(@NonNull String adPosId) {
            this.adPosId = adPosId;
            return this;
        }

        FlutterFullScreenVodAd build() {
            if (manager == null) {
                throw new IllegalStateException("AdInstanceManager cannot not be null.");
            } else if (adPosId == null) {
                throw new IllegalStateException("adPosId cannot not be null.");
            }

            final FlutterFullScreenVodAd rewardVodAd = new FlutterFullScreenVodAd(manager, adPosId);
            return rewardVodAd;
        }
    }

    private FlutterFullScreenVodAd(
            @NonNull AdInstanceManager manager, @NonNull String adPosId) {
        this.manager = manager;
        this.adPosId = adPosId;
    }

    @Override
    void load() {
        fullscreenVideo = new AdKleinFullscreenVideoAd(
                manager.activity, adPosId, 1, false,
                new AdKleinFullscreenVideoAdListener() {
                    @Override
                    public void onAdClose() {
                        manager.onAdClose(FlutterFullScreenVodAd.this);
                    }

                    @Override
                    public void onVideoComplete() {
                    }

                    @Override
                    public void onSkippedVideo() {
                    }

                    @Override
                    public void onError(AdKleinError adKleinError) {
                        manager.onAdFailed(FlutterFullScreenVodAd.this, adKleinError);
                    }

                    @Override
                    public void onAdLoaded() {
                        manager.onAdReceive(FlutterFullScreenVodAd.this);
                    }

                    @Override
                    public void onAdShow() {
                        manager.onAdExpose(FlutterFullScreenVodAd.this);
                    }

                    @Override
                    public void onAdClicked() {
                        manager.onAdClick(FlutterFullScreenVodAd.this);
                    }
                }
        );

        // 加载广告，参数为广告位ID
        fullscreenVideo.load();
    }

    @Override
    public void release() {

    }
}
