import 'ad_klein_base.dart';
import 'ad_klein_flutter_sdk.dart';

class ADKleinSplashAd extends ADKleinAdLoader {
  String posId;
  String imgName;

  ADKleinSplashAd(this.posId, this.imgName) {
    regist();
  }

  void loadAndShow() {
    AdKleinFlutterSdk.loadSplashAd(
        posId: this.posId, adId: this.adId, imgName: this.imgName);
  }

  void release() {
    unregist();
  }
}

class ADKleinFlutterBannerAd extends ADKleinAdView {
  String posId;
  double width;
  double height;

  ADKleinFlutterBannerAd(
      {this.posId = "", this.width = 1080, this.height = 0}) {
    regist();
  }

  void loadAndShow() {
    AdKleinFlutterSdk.loadBannerAd(
        posId: this.posId,
        adId: this.adId,
        adWidth: this.width,
        adHeight: this.height);
  }

  void release() {
    unregist();
  }
}

class ADKleinFlutterNativeAd extends ADKleinAdLoader {
  String posId;
  double width;

  ADKleinFlutterNativeAd({this.posId = "", this.width = 1080}) {
    regist();
  }

  void load() {
    AdKleinFlutterSdk.loadNativeAd(
        posId: this.posId, adId: this.adId, width: this.width);
  }

  void onReceivedHandle(int adViewId, double width, double height) {
    ADKleinFlutterNativeAdView adView = ADKleinFlutterNativeAdView(adViewId);
    adView.height = height;
    adView.width = width;
    if (this.onReceived != null) {
      this.onReceived!(adView);
    }
  }

  void release() {
    unregist();
  }
}

class ADKleinFlutterNativeAdView extends ADKleinAdView {
  ADKleinFlutterNativeAdView(int adId) {
    this.adId = adId;
    regist();
  }

  void release() {
    unregist();
  }
}

class ADKleinRewardAd extends ADKleinAdLoader {
  String posId;

  ADKleinRewardAd({this.posId = ""}) {
    regist();
  }

  void load() {
    AdKleinFlutterSdk.loadRewardAd(posId: this.posId, adId: this.adId);
  }

  void show() {
    AdKleinFlutterSdk.showRewardAd(adId: this.adId);
  }

  void release() {
    unregist();
  }
}

class ADKleinFullScreenVodAd extends ADKleinAdLoader {
  String posId;

  ADKleinFullScreenVodAd({this.posId = ""}) {
    regist();
  }

  void load() {
    AdKleinFlutterSdk.loadFullscreenVodAd(posId: this.posId, adId: this.adId);
  }

  void show() {
    AdKleinFlutterSdk.showFullscreenVodAd(adId: this.adId);
  }

  void release() {
    unregist();
  }
}

class ADKleinIntertitialAd extends ADKleinAdLoader {
  String posId;

  ADKleinIntertitialAd({this.posId = ""}) {
    regist();
  }

  void load() {
    AdKleinFlutterSdk.loadIntertitialAd(posId: this.posId, adId: this.adId);
  }

  void show() {
    AdKleinFlutterSdk.showIntertitialAd(adId: this.adId);
  }

  void release() {
    unregist();
  }
}
